class Slider{
  int id;
  int x;
  int y;
  int w;
  int h;
  PFont font;
  
  int value = 0; // numerical value 0-100
  int sliderPoint = 0; // the x value of the line we are pointing to
  
  Boolean hoverCheck = false;
  Boolean clickCheck = false;
  Boolean percentage = false;
  
  Slider(int id, int x, int y, int w, int h, Boolean percent, PFont font){
    this.id = id;
    this.x = x; 
    this.y = y;
    this.w = w;
    this.h = h;
    this.font = font;
    percentage = percent;
    
    value = 0;
    sliderPoint = x + (value * (w/10));
  }
  
  // MAGIC NUMBERS WHEEEEE
  void drawSlider(){
    stroke(0);
    strokeWeight(1);
    line(x, y+h-2, x+w, y+h-2); // long bar
    for (int i = x; i <(x+w); i+=(w/10)){
      line(i, y+h-1, i, y+h-3); // dashes every 10 values out of 100
    }
    line(x, y+h-5, x, y+h); // Front marker
    line(x+w, y+h-5, x+w, y+h); // End marker
    
    if (hoverCheck) fill(0);
    else fill(255);
    triangle(sliderPoint, y+h-4, sliderPoint + (h/4), y, sliderPoint - (h/4), y);
    
    textFont(font);
    fill(0);
    if (percentage) text(value + " %", x+w + 5, y+(h/2) + 5);
    else text(value, x+w + 5, y+(h/2) + 5);
  }
  
  void updateSlider(){
    int sliderX = sliderPoint - (h/4);
    int sliderY = y;
    int sliderW = h/2;
    int sliderH = h-4;
    
    // check mouseover
    if ((mouseX > sliderX && mouseX < (sliderX + sliderW) && 
        mouseY > sliderY && mouseY < (sliderY + sliderH)) ||
        (mouseX > x && mouseX < (x+w) && mouseY > (y+h-5) && mouseY < (y+h))) 
        hoverCheck = true;
    else hoverCheck = false;
    
    if(clickCheck){
      if (mouseX <= x) sliderPoint = x;
      else if (mouseX >= x + w) sliderPoint = x+w;
      else sliderPoint = mouseX;
      
      value = ((sliderPoint-x)/(w/100)); // Point / step, where step is w/100 (ie 1/100)
    }
  }
  
  boolean checkCollision(){
    if (hoverCheck) return true;
    else return false;
  }
  
  void collide(){
    //println("** Slider clicked: " + value + " **");
    clickCheck = true;
  }
  
  void release(){
    //println("-- Slider released: " + value + " --");
    clickCheck = false;
  }
}
