class Stitch{
  // unique ID
  int ID;
  // coreStitch ID
  int coreStID;
  // slst, ch, sc, etc
  String name;
  // 0-1, determines if we move on to the next anchor
  int w;
  // 0-5, keeps track of stitch heights
  int h;
  // Has a "hook in" as part of its makeup
  Boolean needsAnchor;
  // If it needs an achor, which ID is it?
  int anchorStitch;
  // The image file of the stitch
  PImage img;
  
  // Graphics
  int x;
  int y;
  int drawW;
  int drawH;
  
  Stitch(int id, int coreID, String n, int wid, int hei, Boolean na, int as){
    ID = id;
    coreStID = coreID;
    name = n;
    w = wid;
    h = hei;
    needsAnchor = na;
    anchorStitch = as;
  }
  
  void initGraphics(int x, int y, int wid, int hei, PImage img){
    this.x = x;
    this.y = y;
    drawW = wid;
    drawH = hei;
    this.img = img;
  }
  
  void drawStitch(int x, int y){
    this.x = x;
    this.y = y;
    image(img, x, y - drawH);
  }
  
  Stitch copyStitch(){
    Stitch st = new Stitch(ID, coreStID, name, w, h, needsAnchor, anchorStitch);
    st.initGraphics(x, y, drawW, drawH, img);
    return st;
  }
}
