// Data structures to hold all the UI elements
ArrayList titleLabels = new ArrayList();
ArrayList titleButtons = new ArrayList();

ArrayList genSliders = new ArrayList();
ArrayList genCheckboxes = new ArrayList();
ArrayList genLabels = new ArrayList();

ArrayList holdCheckboxes = new ArrayList();
ArrayList holdLabels = new ArrayList();

ArrayList finishSliders = new ArrayList();
ArrayList finishLabels = new ArrayList();

// Variables controlled by the UI
int numStitches = 0;
int chanceOfRepetition = 0;
int chanceOfSymmetry = 0;
Boolean insertChainAtPeak = false;
int chanceToGroup = 0;
Boolean groupAroundChains = false;
int numFillerStitches = 0;
Boolean horizontalReversal = false;
int amountOffsetRows = 0;
int numFillerRows = 0;
int lengthRows = 5; // ADD UI for me

// Characteristics of generated output
Boolean symmetrical = false;
Boolean clustersOn = false;

// Drawing info
int uiWidth = 250;

// Mode of UI: generate (0), hold (1), or finish (2)
int MODE = 0;

void loadUI(){
  titleLabels.add(new Label(0, 30, 30, "Control Panel", titleFont));
  
  genLabels.add(new Label(1, 7, 65, "# of Stitches", masterFont));
  genSliders.add(new Slider(2, 12, 70, 200, 13, false, masterFont));
  genLabels.add(new Label(3, 7, 105, "% Chance of Repetition", masterFont));
  genSliders.add(new Slider(4, 12, 110, 200, 13, true, masterFont));
  genLabels.add(new Label(5, 7, 145, "% Chance of Symmetry", masterFont));
  genSliders.add(new Slider(6, 12, 150, 200, 13, true, masterFont));
  genLabels.add(new Label(7, 7, 190, "Insert Chain at Symmetrical Peak", masterFont));
  genCheckboxes.add(new CheckBox(8, 177, 180, 12));
  
  genLabels.add(new Label(9, 7, 250, "% Chance to Group into one Anchor", masterFont));
  genSliders.add(new Slider(10, 12, 255, 200, 13, true, masterFont));
  genLabels.add(new Label(11, 7, 295, "Group Around Chains, if any", masterFont));
  genCheckboxes.add(new CheckBox(12, 157, 285, 12));
  
  genLabels.add(new Label(13, 7, 350, "# of Filler Stitches (Between Clusters)", masterFont));
  genSliders.add(new Slider(14, 12, 355, 200, 13, false, masterFont));
  genLabels.add(new Label(15, 7, 395, "Alternate Horizontal Reversal (if applicable)", masterFont));
  genCheckboxes.add(new CheckBox(16, 225, 385, 12));
  
  genLabels.add(new Label(17, 7, 455, "% Offset Even Rows", masterFont));
  genSliders.add(new Slider(18, 12, 460, 200, 13, true, masterFont));
  genLabels.add(new Label(19, 7, 495, "# of Filler Rows", masterFont));
  genSliders.add(new Slider(20, 12, 500, 200, 13, true, masterFont));
  
  titleButtons.add(new Button(21, 90, height-50, 60, 30, "Generate", masterFont));
}

void updateUI(){
  for(int i = 0; i < titleButtons.size(); i++){
    Button b = (Button) titleButtons.get(i);
    b.updateButton();
  }
  for(int i = 0; i < genSliders.size(); i++){
    Slider s = (Slider) genSliders.get(i);
    s.updateSlider();
  }
  for(int i = 0; i < genCheckboxes.size(); i++){
    CheckBox cb = (CheckBox) genCheckboxes.get(i);
    cb.updateCheckBox();
  }
  for(int i = 0; i < holdCheckboxes.size(); i++){
    CheckBox cb = (CheckBox) holdCheckboxes.get(i);
    cb.updateCheckBox();
  }
  for(int i = 0; i < finishSliders.size(); i++){
    Slider s = (Slider) finishSliders.get(i);
    s.updateSlider();
  }
}

void drawUI(){
  stroke(0);
  strokeWeight(1);
  fill(230);
  rect(0, 0, uiWidth, height);
  
  for(int i = 0; i < titleLabels.size(); i++){
    Label l = (Label) titleLabels.get(i);
    l.drawLabel();
  }
  for(int i = 0; i < titleButtons.size(); i++){
    Button b = (Button) titleButtons.get(i);
    b.drawButton();
  }
  for(int i = 0; i < genSliders.size(); i++){
    Slider s = (Slider) genSliders.get(i);
    s.drawSlider();
  }
  for(int i = 0; i < genCheckboxes.size(); i++){
    CheckBox cb = (CheckBox) genCheckboxes.get(i);
    cb.drawCheckBox();
  }
  for(int i = 0; i < genLabels.size(); i++){
    Label l = (Label) genLabels.get(i);
    l.drawLabel();
  }
  for(int i = 0; i < holdCheckboxes.size(); i++){
    CheckBox cb = (CheckBox) holdCheckboxes.get(i);
    cb.drawCheckBox();
  }
  for(int i = 0; i < holdLabels.size(); i++){
    Label l = (Label) holdLabels.get(i);
    l.drawLabel();
  }
  for(int i = 0; i < finishSliders.size(); i++){
    Slider s = (Slider) finishSliders.get(i);
    s.drawSlider();
  }
  for(int i = 0; i < finishLabels.size(); i++){
    Label l = (Label) finishLabels.get(i);
    l.drawLabel();
  }
}

Boolean pressedUI(){
  Boolean collisionDetected = false;
  
  if (mouseX > 0 && mouseX < uiWidth && mouseY > 0 && mouseY < height) collisionDetected = true;
  
  for(int i = 0; i < titleButtons.size(); i++){
    Button b = (Button) titleButtons.get(i);
    if (b.checkCollision()){
      collisionDetected = true;
      b.collide();
    }
  }
  
  for(int i = 0; i < genSliders.size(); i++){
    Slider s = (Slider) genSliders.get(i);
    if (s.checkCollision()){
      collisionDetected = true;
      s.collide();
    }
  }
  for(int i = 0; i < genCheckboxes.size(); i++){
    CheckBox cb = (CheckBox) genCheckboxes.get(i);
    if (cb.checkCollision()){
      collisionDetected = true;
      cb.collide();
    }
  }
  for(int i = 0; i < holdCheckboxes.size(); i++){
    CheckBox cb = (CheckBox) holdCheckboxes.get(i);
    if (cb.checkCollision()){
      collisionDetected = true;
      cb.collide();
    }
  }
  for(int i = 0; i < finishSliders.size(); i++){
    Slider s = (Slider) finishSliders.get(i);
    if (s.checkCollision()){
      collisionDetected = true;
      s.collide();
    }
  }
  
  // Returns true if any UI element is collided with
  return collisionDetected;
}

void releaseUI(){
  for(int i = 0; i < titleButtons.size(); i++){
    Button b = (Button) titleButtons.get(i);
    if (b.clickCheck){ 
      //println("!!! RESOLVE BUTTON CLICK HERE !!!");
      if(b.id == 21) generateStitches();
      b.clickCheck = false;
    }
  }
  for(int i = 0; i < genSliders.size(); i++){
    Slider s = (Slider) genSliders.get(i);
    s.release();
    switch(s.id){
      case 2:
        numStitches = s.value;
        break;
      case 4:
        chanceOfRepetition = s.value;
        break;
      case 6:
        chanceOfSymmetry = s.value;
        break;
      case 10:
        chanceToGroup = s.value;
        break;
      case 14:
        numFillerStitches = s.value;
        break;
      case 18:
        amountOffsetRows = s.value;
        break;
      case 20:
        numFillerRows = s.value;
        break;
      default:
        break;
    }
  }
  for(int i = 0; i < genCheckboxes.size(); i++){
    CheckBox cb = (CheckBox) genCheckboxes.get(i);
    cb.release();
    switch(cb.id){
      case 8:
        if(cb.clicked) insertChainAtPeak = true;
        else insertChainAtPeak = false;
        break;
      case 12:
        if (cb.clicked) groupAroundChains = true;
        else groupAroundChains = false;
        break;
      case 16:
        if (cb.clicked) horizontalReversal = true;
        else horizontalReversal = false;
        break;
      default:
        break;
    }
  }
  
  // snapshot of variables
  /*
  println("--- UI Variables ---");
  println(numStitches);
  println(chanceOfRepetition);
  println(chanceOfSymmetry);
  println(insertChainAtPeak);
  println(chanceToGroup);
  println(groupAroundChains);
  println(numFillerStitches);
  println(horizontalReversal);
  println(amountOffsetRows);
  println(numFillerRows);
  println("----------------------");
  */
}

